/*
 Suma dos números BCD empaquetados de 8 dígitos y deja el resultado 
 en BCD empaquetado.

*/

      .data
num1: .byte  0x35, 0x64, 0x28, 0x01
num2: .byte  0x46, 0x58, 0x90, 0x01
cont: .space 4         @ contador de bytes
dres: .space 4         @ dirección del byte sumado
res:  .space 4         @ dirección del resultado

   .equ   lon, 4       @ longitud del número en bytes
   .equ   mask, 0x0f   @ mascara
   .equ   offset, 0x03 @ desp. al digito menos signif.

   .text
main:
   ldr   r1, =num1     @ cargamos en r1 el byte menos
   add   r1, r1, #offset  
   ldrb  r1, [r1]      @ significativo del primer numero

   ldr   r2, =num2     @ cargamos en r2 el byte menos
   add   r2, r2, #offset   
   ldrb  r2, [r2]      @ significativo del segundo numero

   mov   r3, #lon      @ inicializamos el contador
   ldr   r4, =cont     @ con el tamaño en bytes de los sumandos
   str   r3, [r4]

   ldr   r3, =res      @ inicializamos un puntero al resultado
   add   r3, r3, #offset   
   ldr   r4, = dres    @ empezando por el byte menos significativo
   str   r3, [r4]      

   mov   r5, #0        @ r5: acarreo entre dígitos, inicialmente a 0

bucle:   
   mov   r3, r1        @ copiamos el byte en curso
   mov   r4, r2        @ de ambos números a r3 y r4
   mov   r0, #mask     @ r0: máscara para filtrar 4 bits

   and   r3, r3, r0    @ nos quedamos con el nibble menos 
   and   r4, r4, r0    @ significativo de ambos números (r3 y r4)
   lsr   r1, r1, #4    @ y dejamos preparado el nibble
   lsr   r2, r2, #4    @ mas significativo (r1 y r2)

   add   r6, r3, r4    @ sumamos los dígitos menos significativos
   add   r6, r6, r5    @ y el acarreo (de haberlo) en r6
   cmp   r6, #0x0a     @ ¿da mas de 10?
   blt   rc1           @ si no, el acarreo es 0
   mov   r5, #1        @ si da mas de 10, el acarreo es 1
   sub   r6, r6, #0x0a @ y restamos 10 del resultado
   b     sigu

rc1:   
   mov   r5, #0        @ acarreo a 0

@ tenemos sumados los dos dígitos menos significativos de 
@ un byte en r6, y en r5 el acarreo correspondiente

sigu:   
   mov   r3, r1        @ seguimos con el segundo dígito del byte
   mov   r4, r2        @ hacemos lo mismo que con el primer dígito
   and   r3, r3, r0    @ nos quedamos con el dígito a sumar
   and   r4, r4, r0    @ de ambos bytes
   lsr   r1, r1, #4    @ desplazamos a la derecha
   lsr   r2, r2, #4    @ ambos nibbles y
   add   r7, r3, r4    @ sumamos ambos nibbles con el acarreo
   add   r7, r7, r5    @ del menos significativo al mas significativo
   cmp   r7, #0x0a     @ vemos si hay acarreo, y ajustamos
   blt   rc2           @ el resultado restando 10 si es necesario
   mov   r5, #1         
   sub   r7, r7, #0x0a   
   b     fin

rc2:     
   mov   r5, #0        @ acarreo a 0

@ tenemos sumados los dos dígitos más significativos de 
@ un byte en r7, y en r5 el acarreo correspondiente
  
fin:   
   lsl   r7, r7, #4    @ montamos los dos nibbles
   orr   r6, r6, r7    @ en el byte menos significativo de r6
   ldr   r0, =dres     @ recuperamos la dir. de destino
   ldr   r0, [r0]
   strb  r6, [r0]      @ almacenamos el resultado
   sub   r0, r0, #1    @ y apuntamos al siguiente dígito

   ldr   r3, =cont     @ recuperamos el contador
   ldr   r3, [r3] 
   sub   r3, r3, #1    @ lo decrementamos
   beq   acabo         @ y vemos si acabamos

   ldr   r1, =cont     @ no acabamos: actualizamos
   str   r3, [r1]      @ la dirección de destino
   ldr   r1, =dres     @ y el contador
   str   r0, [r1] 
   
   ldr   r1, =num1     @ cargamos los siguientes dígitos
   add   r1, r1, r3    @ en r1 y r2
   sub   r1, r1, #1    @ utilizamos el contador como
   ldrb  r1, [r1]      @ puntero a la zona de destino
                       @ (el desplazamiento es uno menos
   ldr   r2, =num2     @ de lo que marca el contador)
   add   r2, r2, r3    @ diri = numi + cont - 1
   sub   r2, r2, #1
   ldrb  r2, [r2]

   b     bucle         @ nueva iteración

acabo:   
   wfi
   .end
